Attribute VB_Name = "Module_GMTDates"
Option Explicit
Option Base 1
'############################################################################################
'TIME ZONE INFORMATION
Private Type SYSTEMTIME
        wYear As Integer
        wMonth As Integer
        wDayOfWeek As Integer
        wDay As Integer
        wHour As Integer
        wMinute As Integer
        wSecond As Integer
        wMilliseconds As Integer
End Type
'~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
Declare Sub GetSystemTime Lib "kernel32" _
        (lpSystemTime As SYSTEMTIME)
'~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
Declare Sub GetLocalTime Lib "kernel32" _
        (lpSystemTime As SYSTEMTIME)
'~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    Private ArrMonthNameUSA As Variant
    Private ArrMonthNameLCL As Variant
    Public GMTOffset As Double
'############################################################################################
Public Sub InzGMTOffset()       '-->GMTOffset in Hours, do ONCE at .init
    Dim SysTime As SYSTEMTIME
    Dim LocTime As SYSTEMTIME
    Dim S As String
    Dim L As String
    '~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    GetSystemTime SysTime
    GetLocalTime LocTime
    S = Trim(Str(SysTime.wYear)) & "/" & Trim(Str(SysTime.wMonth)) & "/" & Trim(Str(SysTime.wDay)) & " " & Trim(Str(SysTime.wHour)) & ":" + Trim(Str(SysTime.wMinute)) & ":" & Trim(Str(SysTime.wSecond))
    L = Trim(Str(LocTime.wYear)) & "/" & Trim(Str(LocTime.wMonth)) & "/" & Trim(Str(LocTime.wDay)) & " " & Trim(Str(LocTime.wHour)) & ":" + Trim(Str(LocTime.wMinute)) & ":" & Trim(Str(LocTime.wSecond))
    GMTOffset = (CDate(L) - CDate(S)) * 24
    GMTOffset = CInt(GMTOffset * 10) / 10
    '~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
End Sub
'############################################################################################
Public Sub InzArrMonthName()    '-->Corresponding Local / USA month names, do ONCE at .init
    ReDim ArrMonthNameUSA(12)
    ReDim ArrMonthNameLCL(12)
    Dim i As Integer
    Dim sW1 As String
    '~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    ArrMonthNameUSA = Array("Jan", "Feb", "Mar", "Apr", "May", "Jun", "Jul", "Aug", "Sep", "Oct", "Nov", "Dec")
    'ArrMonthNameLCL = Array("janv", "fvr", "mars", "avr ", "mai ", "juin", "juil", "aot", "sept", "oct ", "nov ", "dc ")
    'This would be the result in France....
    '~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    For i = 1 To 12
        sW1 = Format((i * 30 - 15), "MMM DD YYYY")
        sW1 = Left(sW1, 4)
        ArrMonthNameLCL(i) = sW1
    Next i
    '~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
End Sub
'############################################################################################
Public Function MyGMTDate(ByVal d As String) As Date
    '~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    d = KVMonthName(d)
    MyGMTDate = ResolveDate(d)
    '~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
End Function
'############################################################################################
Public Function MyLCLDate(ByVal d As String) As Date
    '~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    MyLCLDate = MyGMTDate(d) + (GMTOffset / 24)
    '~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
End Function
'############################################################################################
'############################################################################################
Private Function KVMonthName(sW1 As String) As String
    Dim i As Integer
    Dim J As Integer
    '~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    For i = 1 To 12
        J = InStr(1, sW1, ArrMonthNameUSA(i))
        If (J > 0) Then
            KVMonthName = Left(sW1, J - 1) & ArrMonthNameLCL(i) & Mid(sW1, J + 3)
            Exit Function
        End If
    Next i
    '~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    KVMonthName = sW1
    '~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
End Function
'############################################################################################
Private Function ResolveDate(ByVal d As String) As Date
On Error GoTo ResolveError
    Dim tempdate As Date
    Dim X As Long
    Dim a, h, m
    '~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    ResolveDate = 0
    X = InStr(d, ",")
    If X <> 0 Then d = Mid(d, X + 1)
    d = Trim(d)
    X = InStr(d, ":")
    If X <> 0 Then
        X = InStr(X + 1, d, " ")
        a = ""
        If X <> 0 Then a = Trim(Extract(Mid(d, X + 1), "(")): d = Left(d, X - 1)
        h = SafeVal(Left(a, 3)) / 24
        m = SafeVal(Mid(a, 4)) / 60 / 24: If h < 0 Then m = -m
        'MsgBox "d:       " & d & vbLf & _
        '       "tempdate:" & tempdate & vbLf & _
        '       vbLf, vbExclamation, "A"
        tempdate = d                '<-------- This implicit conversion raises the error
        'MsgBox "d:       " & d & vbLf & _
        '       "tempdate:" & tempdate & vbLf & _
        '       vbLf, vbExclamation, "B"
        If tempdate <> 0 Then ResolveDate = tempdate - h - m
    Else
        ResolveDate = d
    End If
Exit Function
ResolveError:
    ResolveDate = 0
    'MsgBox "error", vbCritical
End Function
'############################################################################################
Private Function Extract(a, b) As String
    Dim X As Long
    '~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    X = InStr(a, b)
    If (X = 0) Then
        Extract = a
    Else
        Extract = Left(a, X - 1)
    End If
    '~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
End Function
'############################################################################################
Private Function SafeVal(a) As Double
On Error Resume Next
    '~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    SafeVal = 0
    SafeVal = Val(a)
    '~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
End Function
'############################################################################################

